-------------------------------------------------------------------------------
-- Dumb Knight
--Copyright (C) 2013  Thoughts of Glought

--This program is free software: you can redistribute it and/or modify
--it under the terms of the GNU General Public License as published by
--the Free Software Foundation, either version 3 of the License, or
--(at your option) any later version.
--------------------------------------------------------------------------------
--This program is distributed in the hope that it will be useful,
--but WITHOUT ANY WARRANTY; without even the implied warranty of
--MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
--GNU General Public License for more details.
---------------------------------------------------------------------------------
--You should have received a copy of the GNU General Public License
--along with this program.  If not, see <http://www.gnu.org/licenses/>.
----------------------------------------------------------------------------------




DBK = LibStub("AceAddon-3.0"):NewAddon("Dumbknight","AceEvent-3.0","AceConsole-3.0","AceTimer-3.0")
local AceConfig = LibStub("AceConfig-3.0")
local AceDBOptions = LibStub("AceDBOptions-3.0")
local AceConfigDialog= LibStub("AceConfigDialog-3.0", true)


--Options
DBKoptions = {
	name = "Dumb Knight",
	handler = DBK,
	type = 'group',
	args = {
		fancy = {
			name = 'Fancy Whispers',
			desc = 'If ON it will send out a random funny message letting the dps blood dk know hes in blood.If OFF it will send a generic message instead. Default is ON',
			order = 1,
			type = 'toggle',
			get = "IsFancy",
			set = "SetFancyToggle",
		},
		delay = {
			name = 'Check Delay',
			desc = 'Set how long before checking for DPS Death Knights in Blood spec when entering instance. Default is 60 secs.',
			order = 2,
			type = 'range',
			min =  20,
			max =  120,
			get = "GetDelay",
			set = "SetDelay",
		},
		raidwhispers = {
			name = 'Raid Whispers',
			desc = 'If ON it will run the check on the whole raid group.If OFF it will just run the check on subgroups. Default is ON',
			order = 3,
			type = 'toggle',
			get = "IsRaidWhisper",
			set = "SetRaidWhisperToggle",
		},
	},
}
--Defaults
local defaults = {
	global = {
		fancy = true,
		delay =  60,
        raidwhispers = true,
	},
	profile = {
		fancy = true,
	}
}

function DBK:OnInitialize()
	DBK:Print("Dumb Knight Enabled")
	DBK.db = LibStub("AceDB-3.0"):New("DumbKnightDB", defaults, true)
	AceConfig:RegisterOptionsTable("DBK", DBKoptions, {"/DumbknightSettings", "/dbkset"})
	AceConfigDialog:AddToBlizOptions("DBK", "Dumb Knight")
	DBK.db:RegisterDefaults(defaults)
	local profiles = LibStub("AceDBOptions-3.0"):GetOptionsTable(DBK.db)
end

function DBK:OnEnable()
	DBK:Print("Dumb knight Command: /dbk Runs check and whispers the death knight")
	DBK:RegisterEvent("PLAYER_ENTERING_WORLD", "dbktimerset")
	DBK:RegisterEvent("GROUP_ROSTER_CHANGED", "whisperdk")
	DBK:RegisterChatCommand("Dbk", "whisperdk",true)
end

function DBK:OnDisable()
	DBK:UnregisterChatCommand("Dbk")
end

function DBK:IsFancy(info)
	return DBK.db.global.fancy
end

function DBK:SetFancyToggle(info,value)
	DBK.db.global.fancy = value
end

function DBK:GetDelay(info)
	return DBK.db.global.delay
end

function DBK:SetDelay(info,value)
	DBK.db.global.delay = value
end

function DBK:IsRaidWhisper(info)
	return DBK.db.global.raidwhispers
end

function DBK:SetRaidWhisperToggle(info,value)
	DBK.db.global.raidwhispers = value
end

function DBK:dbktimer()
	DBK:whisperdk()
end

function DBK:dbktimerset()
	DBK:ScheduleTimer("dbktimer", DBK:GetDelay())
end

function DBK:DoTanksayings(name)

	local Random = math.random(1, 10)
    n,r= UnitName(name)n=n and n.. (r and "-"..r or "")
	if (Random == 1) then
		SendChatMessage("I think you meant to queue as a tank because your in blood spec :)","WHISPER",nil,n)
	elseif (Random == 2) then
		SendChatMessage("Blood spec is for tanking please get out of it kind sir or madam.","WHISPER",nil,n)
	elseif (Random == 3) then
		SendChatMessage("You appear to not know how to dps!!!! Step one GET OUT OF BLOOD SPEC!!!! step two pick unholy or frost. Thank you and have a good day.","WHISPER",nil,n)
	elseif (Random == 4) then
		SendChatMessage("Hey man tanking is my job don't take my job bro!! Please leave blood spec.","WHISPER",nil,n)
	elseif (Random == 5) then
		SendChatMessage("I smell blood....OH GOD BRO...thats nasty get out of blood...","WHISPER",nil,n)
	elseif (Random == 6) then
		SendChatMessage("You know blood is not for dps right? just checking.","WHISPER",nil,n)
	elseif (Random == 7) then
		SendChatMessage("I'm going to bloody your lip if you don't get out of blood.","WHISPER",nil,n)
	elseif (Random == 8) then
		SendChatMessage("Death Knight stealing my aggro! please leave blood.","WHISPER",nil,n)
	elseif (Random == 9) then
		SendChatMessage("Do you want to tank? Then queue as tank.","WHISPER",nil,n)
	elseif (Random == 10) then
		SendChatMessage("Hey I didn't queue as healer because I don't plan to heal. So I would assume since you queued as dps you plan on doing dps right? I just ask because your in blood.","WHISPER",nil,n)
	else
	--DBK:Print("Get out of blood!"..playername)
	end
end

function DBK:DoHealersayings(name)

	local Random = math.random(1, 14)
      n,r= UnitName(name)n=n and n.. (r and "-"..r or "")
	if (Random == 1) then
		SendChatMessage("I think you meant to queue as a tank because your in blood spec :)","WHISPER",nil,n)
	elseif (Random == 2) then
		SendChatMessage("Blood spec is for tanking please get out of it kind sir or madam.","WHISPER",nil,n)
	elseif (Random == 3) then
		SendChatMessage("You appear to not know how to dps!!!! Step one GET OUT OF BLOOD SPEC!!!! step two pick unholy or frost. Thank you and have a good day.","WHISPER",nil,n)
	elseif (Random == 4) then
		SendChatMessage("Hey I rather just heal the tank...you know the guy queued as tank...not dps.....please leave blood spec.","WHISPER",nil,n)
	elseif (Random == 5) then
		SendChatMessage("I smell blood....OH GOD BRO...thats nasty get out of blood...","WHISPER",nil,n)
	elseif (Random == 6) then
		SendChatMessage("You know blood is not for dps right? just checking.","WHISPER",nil,n)
	elseif (Random == 7) then
		SendChatMessage("I'm going to bloody your lip if you don't get out of blood.","WHISPER",nil,n)
	elseif (Random == 8) then
		SendChatMessage("Oi good day mate! My heals will stop unless you leave blood!","WHISPER",nil,n)
	elseif (Random == 9) then
		SendChatMessage("Do you want to tank? Then queue as tank.","WHISPER",nil,n)
	elseif (Random == 10) then
		SendChatMessage("I queued as healer the tank queued as tank we are dong our jobs please leave blood so you can do yours!","WHISPER",nil,UnitName(name))
	elseif (Random == 11) then
		SendChatMessage("Oh sorry I would have healed you but i didn't know you were the tank! After all you are showing up as dps but I guess your blood spec is more important","WHISPER",nil,n)
	elseif (Random == 12) then
		SendChatMessage("Never gonna heal you up! Never gonna save your life! Never gonna spec you right! and rez you! Please leave blood:) thank you","WHISPER",nil,n)
	elseif (Random == 13) then
		SendChatMessage("As you can see I spec for healer because I plan to heal. You should spec for dps!","WHISPER",nil,n)
	elseif (Random == 14) then
		SendChatMessage("There once was a dps Death Knight who speced for tanking. Everyone hated him even the healer who refused to heal him....he died....the end","WHISPER",nil,n)
	else
	--DBK:Print("Get out of blood!"..playername)
	end

end

function DBK:DoDpssayings(name)

	local Random = math.random(1, 14)
    
    n,r= UnitName(name)n=n and n.. (r and "-"..r or "")

	if (Random == 1) then
		SendChatMessage("I think you meant to queue as a tank because your in blood spec :)","WHISPER",nil,n)
	elseif (Random == 2) then
		SendChatMessage("Blood spec is for tanking please get out of it kind sir or madam.","WHISPER",nil,n)
	elseif (Random == 3) then
		SendChatMessage("You appear to not know how to dps!!!! Step one GET OUT OF BLOOD SPEC!!!! step two pick unholy or frost. Thank you and have a good day.","WHISPER",nil,n)
	elseif (Random == 4) then
		SendChatMessage("Hey man tanking is my job dont take my job bro!! Please leave blood spec.","WHISPER",nil,n)
	elseif (Random == 5) then
		SendChatMessage("I smell blood....OH GOD BRO...thats nasty get out of blood...","WHISPER",nil,n)
	elseif (Random == 6) then
		SendChatMessage("You know blood is not for dps right? just checking.","WHISPER",nil,n)
	elseif (Random == 7) then
		SendChatMessage("Im going to bloody your lip if you dont get out of blood.","WHISPER",nil,n)
	elseif (Random == 8) then
		SendChatMessage("You can't join the dps club....Because your in tank spec!","WHISPER",nil,n)
	elseif (Random == 9) then
		SendChatMessage("Do you want to tank? Then queue as tank.","WHISPER",nil,n)
	elseif (Random == 10) then
		SendChatMessage("Hey I didn't queue as healer because I don't plan to heal. So I would assume since you queued as dps you plan on doing dps right? I just ask because your in blood.","WHISPER",nil,n)
	elseif (Random == 11) then
		SendChatMessage("Hey your going to piss off the tank bro. Best leave blood spec","WHISPER",nil,n)
	elseif (Random == 12) then
		SendChatMessage("Hey your making the healers job harder then it needs to be please leave blood spec.","WHISPER",nil,n)
	elseif (Random == 13) then
		SendChatMessage("Take it from another dps. dps is a lot easier when your in dps spec.","WHISPER",nil,n)
	elseif (Random == 14) then
		SendChatMessage("Your dps seems low try getting out of tank spec.","WHISPER",nil,n)
	else
	--DBK:Print("Get out of blood!"..playername)
	end
end

function DBK:whisperdk()
	local PP_name
	local PP_class
	local PP_Spec
	local PP_Role
	local Player_Role = UnitGroupRolesAssigned("player")
   
	if IsInGroup() then
		if DBK.db.global.raidwhispers then 
			if IsInRaid() then
				for j = 1, GetNumGroupMembers(), 1 do
					PP_name = UnitName("party"..j)
					PP_class = select(2,UnitClass("party"..j))
					PP_Spec = GetInspectSpecialization("party"..j)
					PP_Role = UnitGroupRolesAssigned("party"..j)
                     n,r= UnitName("party"..j)n=n and n.. (r and "-"..r or "")

					if PP_class == "DEATHKNIGHT" and PP_Spec == 250 and PP_Role ~= "TANK" then
						if DBK.db.global.fancy  then
							if Player_Role == "TANK" then
								DBK:DoTanksayings("party"..j)
							elseif Player_Role == "HEALER" then
								DBK:DoHealersayings("party"..j)
							elseif Player_Role == "DAMAGER" then
								DBK:DoDpssayings("party"..j)
							else
								DBK:Print("you have no role!")
							end
						else
							SendChatMessage("you are in blood spec! Change to your prefered dps spec(unholy or frost)","WHISPER",nil,n)
						end
					else
						--DBK:Print("Not in blood spec(raid)")
					end
				end
			else
				for j = 1, GetNumSubgroupMembers(), 1 do
					PP_name = UnitName("party"..j)
					PP_class = select(2,UnitClass("party"..j))
					PP_Spec = GetInspectSpecialization("party"..j)
					PP_Role = UnitGroupRolesAssigned("party"..j)
                     n,r= UnitName("party"..j)n=n and n.. (r and "-"..r or "")
					if PP_class == "DEATHKNIGHT" and PP_Spec == 250 and PP_Role ~= "TANK" then
						if DBK.db.global.fancy  then
							if Player_Role == "TANK" then
								DBK:DoTanksayings("party"..j)
							elseif Player_Role == "HEALER" then
								DBK:DoHealersayings("party"..j)
							elseif Player_Role == "DAMAGER" then
								DBK:DoDpssayings("party"..j)
							else
								DBK:Print("you have no role!")
							end
						else
							SendChatMessage("you are in blood spec! Change to your prefered dps spec(unholy or frost)","WHISPER",nil,n)
						end
					else
						--DBK:Print("Not in blood spec (dungeon RW ON)")
					end
				end
			end

		else
			for j = 1, GetNumSubgroupMembers(), 1 do
				PP_name = UnitName("party"..j)
				PP_class = select(2,UnitClass("party"..j))
				PP_Spec = GetInspectSpecialization("party"..j)
				PP_Role = UnitGroupRolesAssigned("party"..j)
                n,r= UnitName("party"..j)n=n and n.. (r and "-"..r or "")
				if PP_class == "DEATHKNIGHT" and PP_Spec == 250 and PP_Role ~= "TANK" then
					if DBK.db.global.fancy  then
						if Player_Role == "TANK" then
							DBK:DoTanksayings("party"..j)
						elseif Player_Role == "HEALER" then
							DBK:DoHealersayings("party"..j)
						elseif Player_Role == "DAMAGER" then
							DBK:DoDpssayings("party"..j)
						else
							DBK:Print("you have no role!")
						end
					else
						SendChatMessage("you are in blood spec! Change to your prefered dps spec(unholy or frost)","WHISPER",nil,n)
					end
				else
					--DBK:Print("Not in blood spec (dungeons RW off")
				end
			end
		end

	else
		DBK:Print("Not in group")
	end
end